"use strict";

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Immutable = require('immutable');

var TABLE_JSON_ID = 'SPREAD-JAM-TABLE';

function _bindPrototype(table) {
  table.__proto__ = Table.prototype;
  return table;
}

/**
 * Represents a data table in memory. Immutable
 *
 * This implementation uses nexted hash tables to represent rows/columns.  The
 * advantage of this is that a table with no data can take almost no space.  As
 * the table becomes filled, it will occupy more memory.
 */

var Table = function (_Immutable$Map) {
  _inherits(Table, _Immutable$Map);

  function Table(width, height) {
    var _this, _ret;

    _classCallCheck(this, Table);

    var map = _bindPrototype((_this = _possibleConstructorReturn(this, Object.getPrototypeOf(Table).call(this)), _this));
    return _ret = _bindPrototype(map._setSize(width, height).set('data', new Immutable.Map())), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Table, [{
    key: '_setSize',
    value: function _setSize(width, height) {
      return _get(Object.getPrototypeOf(Table.prototype), 'set', this).call(this, 'width', width).set('height', height);
    }

    /**
     * The width of the table
     * @return {number}
     */

  }, {
    key: '_validate',


    /**
     * Converts negative indicies into positive ones and also validates indices.
     *
     * Throws if coordinates are invalid.
     * @param  {number} x column index, can be negative
     * @param  {number} y row index, can be negative
     * @return {number[]} tuple of x, y indicies
     */
    value: function _validate(x, y) {
      if (x < 0) x += this.width;
      if (y < 0) y += this.height;
      if (x >= this.width) throw new Error('x larger than table width');
      if (y >= this.height) throw new Error('y larger than table height');
      if (x < 0) throw new Error('x less than 0');
      if (y < 0) throw new Error('y less than 0');
      return [x, y];
    }

    /**
     * Gets a value in the table
     * @param {number} x        column index.  Negative numbers can be used to
     *                          address columns from the right side of the table.
     * @param {number} y        row index. Negative numbers can be used to address
     *                          rows from the bottom side of the table.
     * @return {any}
     */

  }, {
    key: 'getCell',
    value: function getCell(x, y, defaultValue) {
      var _validate2 = this._validate(x, y);

      var _validate3 = _slicedToArray(_validate2, 2);

      x = _validate3[0];
      y = _validate3[1];

      return _get(Object.getPrototypeOf(Table.prototype), 'getIn', this).call(this, ['data', x, y], defaultValue);
    }

    /**
     * Sets a value or values in the table.
     * @param {number} x        column index.  Negative numbers can be used to
     *                          address columns from the right side of the table.
     * @param {number} y        row index. Negative numbers can be used to address
     *                          rows from the bottom side of the table.
     * @param {any|Table} value value to set in the table.  If the value is a
     *                          table, the values of that table are used to set
     *                          the equavalent set of cells in the destination at
     *                          the offset specified.
     * @return {Table}          derived table
     */

  }, {
    key: 'setCell',
    value: function setCell(x, y, value) {
      var _this2 = this;

      var _validate4 = this._validate(x, y);

      var _validate5 = _slicedToArray(_validate4, 2);

      x = _validate5[0];
      y = _validate5[1];

      if (value instanceof Table) {
        console.log('b');
        return _bindPrototype(_get(Object.getPrototypeOf(Table.prototype), 'mergeDeep', this).call(this, value.mapKeys(function (fromX) {
          return fromX + x;
        }).filter(function (value, fromX) {
          return fromX < _this2.width;
        }).map(function (map) {
          return map.mapKeys(function (fromY) {
            return fromY + y;
          }).filter(function (value, fromY) {
            return fromY < _this2.height;
          });
        })));
      } else {
        return _bindPrototype(_get(Object.getPrototypeOf(Table.prototype), 'setIn', this).call(this, ['data', x, y], value));
      }
    }

    /**
     * Get a subset of the table
     * @param  {number} startX the left most column index of the subset.  Negative
     *                         numbers can be used to address columns from the
     *                         right side of the table.
     * @param  {number} startY the top most row of the subset.  Negative numbers
     *                         can be used to address rows from the bottom side of
     *                         the table.
     * @param  {number} [endX] the right most column index, exclusive, of the
     *                         subset.  Negative numbers can be used to address
     *                         columns from the right side of the table.
     * @param  {number} [endY] the bottom most row index, exclusive, of the
     *                         subset.  Negative numbers can be used to address
     *                         rows from the bottom side of the table.
     * @return {Table}         subset
     */

  }, {
    key: 'slice',
    value: function slice(startX, startY, endX, endY) {

      // If a right isn't defined, use the right edge and bottom edge for x/y lims

      var _validate6 = this._validate(startX, startY);

      var _validate7 = _slicedToArray(_validate6, 2);

      startX = _validate7[0];
      startY = _validate7[1];
      if (endX === undefined) {
        endX = this.width;
        endY = this.height;
      } else {
        var _validate8 = this._validate(endX, endY);

        var _validate9 = _slicedToArray(_validate8, 2);

        endX = _validate9[0];
        endY = _validate9[1];
      }

      return _bindPrototype(_get(Object.getPrototypeOf(Table.prototype), 'set', this).call(this, 'width', endX - startX).set('height', endY - startY).filter(function (values, fromX) {
        return startX <= fromX && fromX < endX;
      }).mapKeys(function (fromX) {
        return fromX - startX;
      }).map(function (map) {
        return map.filter(function (values, fromY) {
          return startY <= fromY && fromY < endY;
        }).mapKeys(function (fromY) {
          return fromY - startY;
        });
      }));
    }
  }, {
    key: 'equals',
    value: function equals(other) {
      return Immutable.is(this, other);
    }

    /**
     * Serialize the table to a JSON representation.
     *
     * Deserialization can be done using the static Table.makeReviver() function
     * in combination with JSON.parse();
     * @return {string} JSON representation
     */

  }, {
    key: 'toJSON',
    value: function toJSON() {
      var serialized = {};
      serialized[TABLE_JSON_ID] = JSON.stringify(this.toJS());
      return serialized;
    }

    /**
     * Makes a reviver function to be used to deserialize Tables using JSON.parse.
     *
     * Serialization can be done using JSON.stringify(table)
     * @param  {function} [wrappedReviver] optionally specify another reviver
     * @return {function}
     */

  }, {
    key: 'width',
    get: function get() {
      return _get(Object.getPrototypeOf(Table.prototype), 'get', this).call(this, 'width');
    }

    /**
     * The height of the table
     * @return {number}
     */

  }, {
    key: 'height',
    get: function get() {
      return _get(Object.getPrototypeOf(Table.prototype), 'get', this).call(this, 'height');
    }
  }], [{
    key: 'makeReviver',
    value: function makeReviver(wrappedReviver) {
      return function (key, value) {
        if (wrappedReviver) {
          value = wrappedReviver(key, value);
        }

        if (value[TABLE_JSON_ID] !== undefined) {
          var table = new Table(0, 0);
          var internal = JSON.parse(value[TABLE_JSON_ID]);
          return _bindPrototype(table.mergeDeep(Immutable.fromJS(internal)));
        }
        return value;
      };
    }

    /**
     * Create a table from a CSV representation
     * @param  {string} csv comma separated value representation
     * @return {Table}
     */

  }, {
    key: 'fromCSV',
    value: function fromCSV(csv) {
      var width = 0;
      var lines = csv.split('\n').map(function (line) {
        line = line.split(',').map(function (x) {
          return x.trim();
        });
        width = Math.max(width, line.length);
        return line;
      });
      var table = new Table(width, lines.length);
      lines.forEach(function (line, y) {
        line.forEach(function (item, x) {
          table = table.setCell(x, y, item);
        });
      });
      return table;
    }
  }]);

  return Table;
}(Immutable.Map);

exports.Table = Table;